--- doxygen-1.5.8/src/fortranscanner.l	2008-12-22 15:33:27.000000000 +0100
+++ doxygen-1.5.8-new/src/fortranscanner.l	2009-01-27 23:23:20.820297000 +0100
@@ -279,10 +279,10 @@
 
                                             if(indexEnd<0){ // ----- no ampersand as line continuation
                                                if(YY_START == Prepass) { // last line in "continuation"
-                                                 inputStringPrepass+=(const char*)yytext;
-                                                 if(indexStart>=0) inputStringPrepass[yyleng-indexStart]=' ';
-                                                 // @todo: remove all symbols instead of replacing W blank?
 
+                                                 // Only take input after initial ampersand
+                                                 inputStringPrepass+=(const char*)(yytext+(indexStart+1));
+   
                                                  pushBuffer(inputStringPrepass);
                                                  yy_pop_state();
                                                } else { // simple line
@@ -296,12 +296,14 @@
                                                 yy_push_state(Prepass);
                                               }
 
-                                              inputStringPrepass+=(const char*)yytext;
-                                              lineCountPrepass ++;
-  
-                                              // replace & with space and remove following comment if present
                                               int length = inputStringPrepass.length();
-					      truncatePrepass(length-yyleng+indexEnd);
+
+                                              // Only take input after initial ampersand
+                                              inputStringPrepass+=(const char*)(yytext+(indexStart+1));
+                                              lineCountPrepass ++;
+
+                                              // cut off & and remove following comment if present
+					      truncatePrepass(length+indexEnd-(indexStart+1));
                                             }
 
                                         }
@@ -903,8 +905,7 @@
       comments.append(c);
     }
   }
-  inputStringPrepass[index] = ' ';
-  inputStringPrepass.truncate(index+1);
+  inputStringPrepass.truncate(index);
 }
 
 // simplified way to know if this is fixed form
